import 'dart:async';

import 'package:flutter/material.dart';
import 'package:flutter_map_marker_animation/lat_lng_interpolation.dart';
import 'package:flutter_map_marker_animation/models/lat_lng_delta.dart';
import 'package:google_maps_flutter/google_maps_flutter.dart';

class FlutterMapMarkerAnimationExample extends StatefulWidget {
  @override
  _FlutterMapMarkerAnimationExampleState createState() => _FlutterMapMarkerAnimationExampleState();
}

class _FlutterMapMarkerAnimationExampleState extends State<FlutterMapMarkerAnimationExample> {
  LatLngInterpolationStream _latLngStream = LatLngInterpolationStream();
  StreamSubscription<LatLngDelta> subscription;

  @override
  void initState() {
    subscription = _latLngStream.getLatLngInterpolation().listen((LatLngDelta delta) {
      LatLng from = delta.from;
      LatLng to = delta.to;
      double angle = delta.rotation;
    });

    super.initState();
  }

  //...
  //Other Widgets configuration

  void updatePinOnMap(Position currentLocation) {
    var pinPosition = LatLng(currentLocation.latitude, currentLocation.longitude);

    _latLngStream.addLatLng(pinPosition);
  }

  @override
  void dispose() {
    subscription.cancel();
    _latLngStream.cancel();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) => SizedBox.shrink();
}

class Position {
  double latitude;
  double longitude;
}
